{
    "$graph": [
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#emblem_textures.cwl/fill_gradient"
                },
                {
                    "type": "File",
                    "id": "#emblem_textures.cwl/highlight_gradient"
                },
                {
                    "type": "File",
                    "id": "#emblem_textures.cwl/outline"
                }
            ],
            "steps": [
                {
                    "run": "#border_emblem.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/border/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/border/border_emblem"
                    ],
                    "id": "#emblem_textures.cwl/border"
                },
                {
                    "run": "#texture_default.cwl",
                    "in": [
                        {
                            "valueFrom": "$(inputs.outline.nameroot)",
                            "id": "#emblem_textures.cwl/default/file_name"
                        },
                        {
                            "source": "#emblem_textures.cwl/highlight/highlight_emblem",
                            "id": "#emblem_textures.cwl/default/highlight"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/default/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/default/texture"
                    ],
                    "id": "#emblem_textures.cwl/default"
                },
                {
                    "run": "#gradient_emblem.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/fill_gradient",
                            "id": "#emblem_textures.cwl/gradient/fill_gradient"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/gradient/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/gradient/gradient_emblem"
                    ],
                    "id": "#emblem_textures.cwl/gradient"
                },
                {
                    "run": "#highlight_emblem.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/gradient/gradient_emblem",
                            "id": "#emblem_textures.cwl/highlight/gradient_emblem"
                        },
                        {
                            "source": "#emblem_textures.cwl/highlight_mask/highlight_mask",
                            "id": "#emblem_textures.cwl/highlight/gradient_mask"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/highlight/highlight_emblem"
                    ],
                    "id": "#emblem_textures.cwl/highlight"
                },
                {
                    "run": "#highlight_mask.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/highlight_gradient",
                            "id": "#emblem_textures.cwl/highlight_mask/gradient_mask"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/highlight_mask/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/highlight_mask/highlight_mask"
                    ],
                    "id": "#emblem_textures.cwl/highlight_mask"
                },
                {
                    "run": "#texture_map.cwl",
                    "in": [
                        {
                            "valueFrom": "$(inputs.outline.nameroot)",
                            "id": "#emblem_textures.cwl/map/file_name"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/map/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/map/texture"
                    ],
                    "id": "#emblem_textures.cwl/map"
                },
                {
                    "run": "#texture_small.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/border/border_emblem",
                            "id": "#emblem_textures.cwl/small/border"
                        },
                        {
                            "valueFrom": "$(inputs.outline.nameroot)",
                            "id": "#emblem_textures.cwl/small/file_name"
                        },
                        {
                            "source": "#emblem_textures.cwl/highlight/highlight_emblem",
                            "id": "#emblem_textures.cwl/small/highlight"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/small/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/small/texture"
                    ],
                    "id": "#emblem_textures.cwl/small"
                }
            ],
            "id": "#emblem_textures.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#emblem_textures.cwl/default/texture",
                    "id": "#emblem_textures.cwl/texture_default"
                },
                {
                    "type": "File",
                    "outputSource": "#emblem_textures.cwl/map/texture",
                    "id": "#emblem_textures.cwl/texture_map"
                },
                {
                    "type": "File",
                    "outputSource": "#emblem_textures.cwl/small/texture",
                    "id": "#emblem_textures.cwl/texture_small"
                }
            ]
        },
        {
            "doc": "Create emblem textures",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/outlines"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "outputSource": "#main/organize/folders",
                    "id": "#main/texture_map"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/outlines",
                            "id": "#main/extractListing/folder"
                        }
                    ],
                    "out": [
                        "#main/extractListing/outlines"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "inputs": [
                            {
                                "type": "Directory",
                                "id": "#main/extractListing/181234a0-d260-47de-aa16-accc93939ed3/folder"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/extractListing/181234a0-d260-47de-aa16-accc93939ed3/outlines"
                            }
                        ],
                        "expression": "$({ \"outlines\": inputs.folder.listing })\n",
                        "id": "#main/extractListing/181234a0-d260-47de-aa16-accc93939ed3"
                    },
                    "id": "#main/extractListing"
                },
                {
                    "run": "#gradients_gen.cwl",
                    "in": [],
                    "out": [
                        "#main/gradients/fill_gradient",
                        "#main/gradients/highlight_gradient"
                    ],
                    "id": "#main/gradients"
                },
                {
                    "in": [
                        {
                            "source": "#main/textures/texture_default",
                            "id": "#main/organize/default"
                        },
                        {
                            "source": "#main/textures/texture_map",
                            "id": "#main/organize/map"
                        },
                        {
                            "source": "#main/textures/texture_small",
                            "id": "#main/organize/small"
                        }
                    ],
                    "out": [
                        "#main/organize/folders"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "id": "#main/organize/organize",
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/organize/organize/map"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "Directory"
                                },
                                "id": "#main/organize/organize/folders"
                            }
                        ],
                        "expression": "${\n  var folders = [];\n  folders.push({\n    \"class\": \"Directory\",\n    \"basename\": \"out\",\n    \"listing\": inputs.default\n  });\n  folders.push({\n    \"class\": \"Directory\",\n    \"basename\": \"out/map\",\n    \"listing\": inputs.map\n  });\n  folders.push({\n    \"class\": \"Directory\",\n    \"basename\": \"out/small\",\n    \"listing\": inputs.small\n  });\n  return { \"folders\": folders };\n}\n"
                    },
                    "id": "#main/organize"
                },
                {
                    "run": "#emblem_textures.cwl",
                    "scatter": "#main/textures/outline",
                    "in": [
                        {
                            "source": "#main/gradients/fill_gradient",
                            "id": "#main/textures/fill_gradient"
                        },
                        {
                            "source": "#main/gradients/highlight_gradient",
                            "id": "#main/textures/highlight_gradient"
                        },
                        {
                            "source": "#main/extractListing/outlines",
                            "id": "#main/textures/outline"
                        }
                    ],
                    "out": [
                        "#main/textures/texture_default",
                        "#main/textures/texture_map",
                        "#main/textures/texture_small"
                    ],
                    "id": "#main/textures"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/border_emblem.sh"
                    },
                    "id": "#border_emblem.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#border_emblem.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "border_emblem.png"
                    },
                    "id": "#border_emblem.cwl/border_emblem"
                }
            ],
            "id": "#border_emblem.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/gradient_emblem.sh"
                    },
                    "id": "#gradient_emblem.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#gradient_emblem.cwl/fill_gradient"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#gradient_emblem.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "gradient_emblem.png"
                    },
                    "id": "#gradient_emblem.cwl/gradient_emblem"
                }
            ],
            "id": "#gradient_emblem.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/gradients_gen.sh"
                    },
                    "id": "#gradients_gen.cwl/command"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "fill_gradient.png"
                    },
                    "id": "#gradients_gen.cwl/fill_gradient"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "highlight_gradient.png"
                    },
                    "id": "#gradients_gen.cwl/highlight_gradient"
                }
            ],
            "id": "#gradients_gen.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/highlight_emblem.sh"
                    },
                    "id": "#highlight_emblem.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#highlight_emblem.cwl/gradient_emblem"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#highlight_emblem.cwl/gradient_mask"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "highlight_emblem.png"
                    },
                    "id": "#highlight_emblem.cwl/highlight_emblem"
                }
            ],
            "id": "#highlight_emblem.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/highlight_mask.sh"
                    },
                    "id": "#highlight_mask.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#highlight_mask.cwl/gradient_mask"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#highlight_mask.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "highlight_mask.png"
                    },
                    "id": "#highlight_mask.cwl/highlight_mask"
                }
            ],
            "id": "#highlight_mask.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/texture_default.sh"
                    },
                    "id": "#texture_default.cwl/command"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#texture_default.cwl/file_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#texture_default.cwl/highlight"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name).dds"
                    },
                    "id": "#texture_default.cwl/texture"
                }
            ],
            "id": "#texture_default.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/texture_map.sh"
                    },
                    "id": "#texture_map.cwl/command"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#texture_map.cwl/file_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#texture_map.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name).dds"
                    },
                    "id": "#texture_map.cwl/texture"
                }
            ],
            "id": "#texture_map.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#texture_small.cwl/border"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://raw.githubusercontent.com/undu/stellaris-emblem-lab/aca472a8f0b95118e227f98fc0d550ad651ff631/textures/tools/texture_small.sh"
                    },
                    "id": "#texture_small.cwl/command"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#texture_small.cwl/file_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#texture_small.cwl/highlight"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name).dds"
                    },
                    "id": "#texture_small.cwl/texture"
                }
            ],
            "id": "#texture_small.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
